//% color="#17959d" iconWidth=50 iconHeight=40
namespace ASR {
    //% block="initialize ASR TX(Green)[TX_PIN] RX(Blue)[RX_PIN]" blockType="command"
    //% TX_PIN.shadow="dropdown" TX_PIN.options="PIN" 
    //% RX_PIN.shadow="dropdown" RX_PIN.options="PIN" 
    export function set(parameter: any, block: any) {
        let pin = parameter.TX_PIN.code;
        pin0=21;
        Generator.addInclude("addIncludeSoftwareSerial","#include <SoftwareSerial.h>");
        Generator.addObject("addasr","SoftwareSerial",`asr(${pin}, ${pin0});`);
        Generator.addSetup("GTSerialSetup",`asr.begin(115200);`);

    }

    //% block="Is there ASR data to read?" blockType="boolean"
    export function available(parameter: any, block: any) {

        Generator.addCode(`asr.available()`);

    }

    //% block="Is Audio Awaked?" blockType="boolean"
    export function awaked(parameter: any, block: any) {
        Generator.addCode(`asr.read() == '100'`);

    }
	
	
    //% block="Is LED Control KeyWords Reconized[LedControl]" blockType="boolean"
    //% LedControl.shadow="dropdown" LedControl.options="LedControl" 	
    export function LedControl(parameter: any, block: any) {
        let LedControl = parameter.LedControl.code;
        Generator.addCode(`asr.read() == ${LedControl}`);

    }
	
	
    //% block="Is Action KeyWords Reconized[Action]" blockType="boolean"
    //% Action.shadow="dropdown" Action.options="Action" 	
    export function Action(parameter: any, block: any) {
        let Action = parameter.Action.code;
        Generator.addCode(`asr.read() == ${Action}`);

    }

	
	
    //% block="Is Query KeyWords Reconized[Query]" blockType="boolean"
    //% Query.shadow="dropdown" Query.options="Query" 	
    export function Query(parameter: any, block: any) {
        let Query = parameter.Query.code;
        Generator.addCode(`asr.read() == ${Query}`);

    }

	
	
    //% block="Is Custom KeyWords Reconized[CustomWords]" blockType="boolean"
    //% CustomWords.shadow="dropdown" CustomWords.options="CustomWords" 	
    export function CustomWords(parameter: any, block: any) {
        let CustomWords = parameter.CustomWords.code;
        Generator.addCode(`asr.read() == ${CustomWords}`);

    }
	
}
